﻿
using System;
using System.Threading;
using Wisej.Web;

namespace BackgroundTasks2
{
    public partial class Page1 : Page
    {
        private static int n10 = 0;
        private static int n5 = 0;
        private static bool _stop = false;

        public class BackgroundServiceEventArgs : EventArgs
        {
            public BackgroundServiceEventArgs(string message)
            {
                this.Message = message;
            }
            public string Message
            {
                get;
                private set;
            }
        }        
        public delegate void BackgroundServiceEventHandler(object sender, BackgroundServiceEventArgs e);
        
        public static event BackgroundServiceEventHandler Message10;
        public static event BackgroundServiceEventHandler Message5;
        public Page1()
        {
            InitializeComponent();

            Application.ApplicationExit += (s, e) =>
            {
                if (Message10 != null)
                    Message10 -= BackgroundService_Message10;
                if (Message5 != null)
                    Message5 -= BackgroundService_Message5;                
            };
        }

        private void Page1_Load(object sender, EventArgs e)
        {
            // defaults
            this.checkBoxActive1.Checked = true;            

            Application.StartTask(() =>
            {                
                while (!_stop)
                {
                    Thread.Sleep(500);
                    DateTime now = DateTime.Now;

                    this.label1.Text = now.ToLongTimeString();
                    Application.Update(this);

                    if (now.Second % 10 == 0)
                    {
                        if (Message10 != null)
                        {
                            Message10(null, new BackgroundServiceEventArgs(n10.ToString()));
                            n10++;
                        }

                    }
                    if (now.Second % 5 == 0)
                    {
                        if (Message5 != null)
                        {
                            n5++;
                            Message5(null, new BackgroundServiceEventArgs(n5.ToString()));
                        }
                    }
                }
            });
        }    

        public static void Stop()
        {
            _stop = true;
        }

        private void BackgroundService_Message5(object sender, BackgroundServiceEventArgs e)
        {
            Application.Update(this, () =>
            {
                this.bubbleNotification1.SetBubbleValue(textBoxCount5, Convert.ToInt32(e.Message));
                this.textBoxCount5.Text = e.Message;
            });
        }

        private void BackgroundService_Message10(object sender, BackgroundServiceEventArgs e)
        {
            Application.Update(this, () =>
            {
                this.bubbleNotification1.SetBubbleValue(textBoxCount10, Convert.ToInt32(e.Message));
                this.textBoxCount10.Text = e.Message;
            });
        }

        private void checkBoxActive1_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            if (cb.Checked)
            {
                Message10 += BackgroundService_Message10;
            }
            else
            {
                Message10 -= BackgroundService_Message10;
            }
        }

        private void checkBoxActive2_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            if (cb.Checked)
            {
                Message5 += BackgroundService_Message5;
            }
            else
            {
                Message5 -= BackgroundService_Message5;
            }
        }
    }
}

